const redis = require('redis');
const {promisify} = require('util');
const client = redis.createClient(process.env.REDIS_URL);

module.exports = {
  ...client,
  flushallAsync: promisify(client.flushall).bind(client),
  expireAsync: promisify(client.expire).bind(client),
  getAsync: promisify(client.get).bind(client),
  setAsync: promisify(client.set).bind(client),
  delAsync: promisify(client.del).bind(client),
  scanAsync: promisify(client.scan).bind(client),
  keysAsync: promisify(client.keys).bind(client)
};