const _ = require("lodash");

const getRatingByField = ({
  limits, value, minNameField, maxNameField,
}) => {
  const maxMarkLimit = _.maxBy(limits, "mark");
  const minMarkLimit = _.minBy(limits, "mark");
  if (Number(value) > Number(minMarkLimit[maxNameField])
  || Number(value) < Number(maxMarkLimit[minNameField])) {
    return minMarkLimit.mark;
  }

  const result = limits
    .sort((a, b) => Number(a.mark) > Number(b.mark))
    .reduce((acc, limit) => {
      if (
        Number(limit[minNameField]) <= Number(value)
        && Number(value) <= Number(limit[maxNameField])
      ) {
        return limit;
      }
      return acc;
    });
  return result.mark;
};

module.exports = getRatingByField;