const axios = require('axios');
const _ = require("lodash");

const objectToQueryString = (obj) => Object.keys(obj)
  .flatMap((key) => {
    const elm = _.isArray(obj[key])
      ? _.map(obj[key], (v) => `${key}[]=${encodeURIComponent(v)}`)
      : _.isObject(obj[key])
        ? _.map(obj[key], (v, k) => `${key}[${k}]=${encodeURIComponent(v)}`)
        : `${key}=${encodeURIComponent(obj[key])}`;

    return elm;
  })
  .join('&');

const getRequest = async (url, params) => {
  if (params) {
    url += `?${objectToQueryString(params)}`;
  }
  const result = await axios({
    url: `${process.env.API_HOST}/${url}`,
    method: 'get',
    headers: {
      'X-Username': `agrocacher [GET ${url}]`,
      Accept: 'application/ld+json',
      'Content-Type': 'application/ld+json',
    },
  })
    .then((res) => res.data)
    .catch((error) => error);
  return result;
};

module.exports = getRequest;
