const redisClient = require("../client");
const _ = require('lodash');

const ApkFlushService = async (req, res) => {
  try {
    await redisClient
      .scanAsync("0", "MATCH", `apkData*`, "COUNT", "100000")
      .then(keys => keys[1])   
      .then(keys => _.each(keys, key => redisClient.delAsync(key)));
      
    return res.send({
      error: false,
      message: "DONE!",
    });
  } catch(e) {
    console.error(e);
    
    return res.status(500).send({
      error: true,
      message: "[/apk-flush] error!",
    });    
  }
};

module.exports = ApkFlushService;
