const redisClient = require("../client");
const _ = require('lodash');

const EventService = async (req, res) => {
  try {
    const { key } = req.params;

    const keys = await redisClient
      .scanAsync("0", "MATCH", `event-${key}-*`, "COUNT", "100000")
      .catch((e) => {
        console.log("ERROR", "EVENTS ERROR", e);

        return false;
      });

    if (keys) {
      const events = [];

      await Promise.all(
        _.map(_.sortBy(keys[1], [(k) => k]), async (k) => {
          const rawData = await redisClient.getAsync(k);

          // после прочтения уничтожить
	  await redisClient.delAsync(k);

          if (rawData) {
            events.push(JSON.parse(rawData));
          }
        })
      );

      console.log(`WORKER EVENTS REQUEST [${key}] [${events.length}]`);

      return res.json(events);
    } else {
      return res.status(500).send({
        error: true,
        message: "Tasks error!",
      });
    }
  } catch(e) {
    console.error(e);
    
    return res.status(500).send({
      error: true,
      message: "[/events] error!",
    });    
  }  
};

module.exports = EventService;
