const redisClient = require("../client");

const ListService = async (req, res) => {
  try {
    const keys = await redisClient
      .scanAsync("0", "COUNT", "100000")
      .catch((e) => {
        console.log("ERROR", "LIST ERROR", e);

        return false;
      });

    if (keys) {
      console.log("LIST REQUEST");
      return res.json(keys[1]);
    } else {
      throw new Error('List error!');
    }
  } catch(e) {
    console.error(e);

    return res.status(500).send({
      error: true,
      message: "[/list] error!",
    });    
  }  
};

module.exports = ListService;
