const redisClient = require("../client");
const _ = require('lodash');

const StoreService = async (req, res) => {
  try {
    const key = req.body.key;
    const expire = req.body.expire;
    const value = req.body.payload;

    if (!key || !value) {
      console.log("ERROR", "KEY MISSING", req.body);

      return res.status(400).send({
        error: true,
        message: "Data missing!",
      });
    }

    await redisClient.setAsync(key, JSON.stringify(value));
    if (expire) {
      await redisClient.expireAsync(key, expire);
    }

    console.info(`KEY CREATED [${key}] WITH EXPIRE [${expire}]`);

    return res.send({
      error: false,
      message: "SUCCESS!",
    });
  } catch(e) {
    console.error(e);

    return res.status(500).send({
      error: true,
      message: "[/store] error!",
    });    
  } 
};

module.exports = StoreService;
