const redisClient = require("../client");
const _ = require('lodash');

const TasksService = async (req, res) => {
  try {
    const { key } = req.params;

    const keys = await redisClient
      .scanAsync("0", "MATCH", `${key}-*`, "COUNT", "100000")
      .catch((e) => {
        console.log("ERROR", "TASKS ERROR", e);

        return false;
      });

    if (keys) {
      const tasks = [];

      await Promise.all(
        _.map(keys[1], async (k) => {
          const rawData = await redisClient.getAsync(k);

          if (rawData) {
            tasks.push(JSON.parse(rawData));
          }
        })
      );

      console.log(`WORKER TASKS REQUEST [${key}] [${tasks.length}]`);

      return res.json(tasks);
    } else {
      return res.status(500).send({
        error: true,
        message: "Tasks error!",
      });
    }
  } catch(e) {
    console.error(e);

    return res.status(500).send({
      error: true,
      message: "[/tasks] error!",
    });    
  }  
};

module.exports = TasksService;
